import { __private, _decorator, Component, ConfigurableConstraint, director, EventKeyboard, Input, input, KeyCode, math, Node, physics, RigidBody, Vec3 } from 'cc';
import { car, key_status } from './car';

const { ccclass, property } = _decorator;

@ccclass('main')
export class main extends Component {

    // CAR
    car = new car();
    key_status = new key_status();
    

    start() {
        this.car.carNode = director.getScene().getChildByPath("CarPhisycs");
        this.car.wheel1lNode = director.getScene().getChildByPath("CarPhisycs/wheels").children;
        this.car.hubNode = director.getScene().getChildByPath("CarPhisycs/hub").children;
        
        input.on(Input.EventType.KEY_DOWN, this.KeyDown, this);
        input.on(Input.EventType.KEY_UP, this.KeyUp, this);
        
    }
    setDrivingSpeed(speed: number) {
       
        this.car.wheel1lNode.forEach(wheel => {
            let newSpeed = speed * 10; 
            let com = wheel.getComponent(ConfigurableConstraint);
            if (com) {
                com.angularDriverSettings.targetVelocity.x = newSpeed;
                com.angularDriverSettings.targetVelocity = com.angularDriverSettings.targetVelocity;
            }
        });
        
    }
    setDrivingForce(strength: number) {
        this.car.wheel1lNode.forEach(wheel => {
            const com = wheel.getComponent(ConfigurableConstraint);
            if (com) {
                com.angularDriverSettings.strength = strength;
            }
        });
    }
    stopAuto(){
        this.car.wheel1lNode.forEach(wheel => {
            const com = wheel.getComponent(RigidBody);
            if (com) {

                com.clearState();
                this.setDrivingSpeed(0);
                this.setDrivingForce(0);

            }
        });
                
    }


    KeyDown(key: EventKeyboard){

        if (key.keyCode === KeyCode.ARROW_UP) {
            this.key_status.gearUp = true;
           
        }
    
        if (key.keyCode === KeyCode.ARROW_DOWN) {
            this.key_status.gearDown = true;
        }
    
        if (key.keyCode === KeyCode.ARROW_LEFT) {
            this.key_status.left = true;
        }
        if (key.keyCode === KeyCode.ARROW_RIGHT) {
            this.key_status.right = true;
        }

    }

    KeyUp(key: EventKeyboard) {
        if (key.keyCode === KeyCode.ARROW_UP) {
            this.key_status.gearUp = false;
            this.stopAuto();
            this.key_status.currentDirection = "";
            
        }
    
        if (key.keyCode === KeyCode.ARROW_DOWN) {
            this.key_status.gearDown = false;
            this.stopAuto();
            this.key_status.currentDirection = "";
        }
    
        if (key.keyCode === KeyCode.ARROW_LEFT) {
            this.key_status.left = false;
        }
        if (key.keyCode === KeyCode.ARROW_RIGHT) {
            this.key_status.right = false;
        }
    }
   
   
    

   

    setSteeringAngle(steeringDelta: number) {
        this.car.hubNode.forEach(hub => {
            let z = 0;
            if (hub.name == "1left" || hub.name == "1right") {

                let smoothedSteeringAngle = hub.getComponent(ConfigurableConstraint).angularDriverSettings.targetOrientation.z;
                z = math.lerp(smoothedSteeringAngle, steeringDelta, 0.08);
                let com0 = hub.getComponent(ConfigurableConstraint);
               
                com0.angularDriverSettings.targetOrientation = new Vec3(com0.angularDriverSettings.targetOrientation.x, com0.angularDriverSettings.targetOrientation.y, z);
                
                
                console.log(com0.angularDriverSettings.targetOrientation)
            }
        });
        
    }
 


    update(dt: number) {
        
        if(this.key_status.left){
            this.setSteeringAngle(30);
       }

       if(this.key_status.right){
           
            this.setSteeringAngle(-30);
       }

       if(this.key_status.gearUp){
        
            this.setDrivingSpeed(100);
            this.setDrivingForce(500);
       }
       if(this.key_status.gearDown){
        
        this.setDrivingSpeed(-100);
        this.setDrivingForce(500);
        }


    }

    
   
}

